/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.330 Revision 1.363
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.330 2010/02/15 02:10:39 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.363 2011/09/12 20:44:01 mgorny Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
49 sleep 1 49 sleep 1
50 done 50 done
51 fi 51 fi
52} 52}
53 53
54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
54fi 76fi
55 77
56# @FUNCTION: ecvs_clean 78# @FUNCTION: ecvs_clean
57# @USAGE: [list of dirs] 79# @USAGE: [list of dirs]
58# @DESCRIPTION: 80# @DESCRIPTION:
179# If you do not specify any options, then epatch will default to the directory 201# If you do not specify any options, then epatch will default to the directory
180# specified by EPATCH_SOURCE. 202# specified by EPATCH_SOURCE.
181# 203#
182# When processing directories, epatch will apply all patches that match: 204# When processing directories, epatch will apply all patches that match:
183# @CODE 205# @CODE
184# ${EPATCH_FORCE} == "yes" 206# if ${EPATCH_FORCE} != "yes"
185# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
186# else 208# else
187# *.${EPATCH_SUFFIX} 209# *.${EPATCH_SUFFIX}
188# @CODE 210# @CODE
189# The leading ?? are typically numbers used to force consistent patch ordering. 211# The leading ?? are typically numbers used to force consistent patch ordering.
228 local EPATCH_SUFFIX=$1 250 local EPATCH_SUFFIX=$1
229 251
230 elif [[ -d $1 ]] ; then 252 elif [[ -d $1 ]] ; then
231 # Some people like to make dirs of patches w/out suffixes (vim) 253 # Some people like to make dirs of patches w/out suffixes (vim)
232 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"} 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
233 260
234 else 261 else
235 # sanity check ... if it isn't a dir or file, wtf man ? 262 # sanity check ... if it isn't a dir or file, wtf man ?
236 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1 263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
237 echo 264 echo
268 # ???_arch_foo.patch 295 # ???_arch_foo.patch
269 # Else, skip this input altogether 296 # Else, skip this input altogether
270 local a=${patchname#*_} # strip the ???_ 297 local a=${patchname#*_} # strip the ???_
271 a=${a%%_*} # strip the _foo.patch 298 a=${a%%_*} # strip the _foo.patch
272 if ! [[ ${SINGLE_PATCH} == "yes" || \ 299 if ! [[ ${SINGLE_PATCH} == "yes" || \
273 ${EPATCH_FORCE} == "yes" || \ 300 ${EPATCH_FORCE} == "yes" || \
274 ${a} == all || \ 301 ${a} == all || \
275 ${a} == ${ARCH} ]] 302 ${a} == ${ARCH} ]]
276 then 303 then
277 continue 304 continue
278 fi 305 fi
279 306
280 # Let people filter things dynamically 307 # Let people filter things dynamically
337 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }') 364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
338 if [[ -n ${abs_paths} ]] ; then 365 if [[ -n ${abs_paths} ]] ; then
339 count=1 366 count=1
340 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}" 367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
341 fi 368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
342 376
343 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/ 377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
344 while [[ ${count} -lt 5 ]] ; do 378 while [[ ${count} -lt 5 ]] ; do
345 # Generate some useful debug info ... 379 # Generate some useful debug info ...
346 ( 380 (
347 _epatch_draw_line "***** ${patchname} *****" 381 _epatch_draw_line "***** ${patchname} *****"
348 echo 382 echo
349 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
350 echo 384 echo
351 _epatch_draw_line "***** ${patchname} *****" 385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
352 ) >> "${STDERR_TARGET}" 391 ) >> "${STDERR_TARGET}"
353 392
354 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then 393 if [ $? -eq 0 ] ; then
355 ( 394 (
356 _epatch_draw_line "***** ${patchname} *****" 395 _epatch_draw_line "***** ${patchname} *****"
357 echo 396 echo
358 echo "ACTUALLY APPLYING ${patchname} ..." 397 echo "ACTUALLY APPLYING ${patchname} ..."
359 echo 398 echo
360 _epatch_draw_line "***** ${patchname} *****" 399 _epatch_draw_line "***** ${patchname} *****"
361 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1 400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
362 ) >> "${STDERR_TARGET}" 405 ) >> "${STDERR_TARGET}"
363 406
364 if [ $? -ne 0 ] ; then 407 if [ $? -ne 0 ] ; then
365 echo 408 echo
366 eerror "A dry-run of patch command succeeded, but actually" 409 eerror "A dry-run of patch command succeeded, but actually"
397 done 440 done
398 441
399 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching" 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
400 : # everything worked 443 : # everything worked
401} 444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
402epatch_user() { 472epatch_user() {
403 [[ $# -ne 0 ]] && die "epatch_user takes no options" 473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
404 478
405 # don't clobber any EPATCH vars that the parent might want 479 # don't clobber any EPATCH vars that the parent might want
406 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches 480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
407 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do 481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
408 EPATCH_SOURCE=${base}/${CTARGET}/${check} 482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
412 EPATCH_SOURCE=${EPATCH_SOURCE} \ 486 EPATCH_SOURCE=${EPATCH_SOURCE} \
413 EPATCH_SUFFIX="patch" \ 487 EPATCH_SUFFIX="patch" \
414 EPATCH_FORCE="yes" \ 488 EPATCH_FORCE="yes" \
415 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \ 489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
416 epatch 490 epatch
417 break 491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
418 fi 493 fi
419 done 494 done
495 echo "none" > "${applied}"
496 return 1
420} 497}
421 498
422# @FUNCTION: emktemp 499# @FUNCTION: emktemp
423# @USAGE: [temp dir] 500# @USAGE: [temp dir]
424# @DESCRIPTION: 501# @DESCRIPTION:
468egetent() { 545egetent() {
469 case ${CHOST} in 546 case ${CHOST} in
470 *-darwin[678]) 547 *-darwin[678])
471 case "$2" in 548 case "$2" in
472 *[!0-9]*) # Non numeric 549 *[!0-9]*) # Non numeric
473 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 550 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
474 ;; 551 ;;
475 *) # Numeric 552 *) # Numeric
476 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 553 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
477 ;; 554 ;;
478 esac 555 esac
696 fi 773 fi
697 ;; 774 ;;
698 775
699 *) 776 *)
700 if [[ -z $@ ]] ; then 777 if [[ -z $@ ]] ; then
701 useradd ${opts} \ 778 useradd -r ${opts} \
702 -c "added by portage for ${PN}" \ 779 -c "added by portage for ${PN}" \
703 ${euser} \ 780 ${euser} \
704 || die "enewuser failed" 781 || die "enewuser failed"
705 else 782 else
706 einfo " - Extra: $@" 783 einfo " - Extra: $@"
707 useradd ${opts} "$@" \ 784 useradd -r ${opts} "$@" \
708 ${euser} \ 785 ${euser} \
709 || die "enewuser failed" 786 || die "enewuser failed"
710 fi 787 fi
711 ;; 788 ;;
712 esac 789 esac
825 esac 902 esac
826 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 903 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
827 ;; 904 ;;
828 905
829 *) 906 *)
907 # We specify -r so that we get a GID in the system range from login.defs
830 groupadd ${opts} ${egroup} || die "enewgroup failed" 908 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
831 ;; 909 ;;
832 esac 910 esac
833 export SANDBOX_ON="${oldsandbox}" 911 export SANDBOX_ON="${oldsandbox}"
834} 912}
835 913
846 924
847# Make a desktop file ! 925# Make a desktop file !
848# Great for making those icons in kde/gnome startmenu ! 926# Great for making those icons in kde/gnome startmenu !
849# Amaze your friends ! Get the women ! Join today ! 927# Amaze your friends ! Get the women ! Join today !
850# 928#
851# make_desktop_entry(<command>, [name], [icon], [type], [path]) 929# make_desktop_entry(<command>, [name], [icon], [type], [fields])
852# 930#
853# binary: what command does the app run with ? 931# binary: what command does the app run with ?
854# name: the name that will show up in the menu 932# name: the name that will show up in the menu
855# icon: give your little like a pretty little icon ... 933# icon: give your little like a pretty little icon ...
856# this can be relative (to /usr/share/pixmaps) or 934# this can be relative (to /usr/share/pixmaps) or
857# a full path to an icon 935# a full path to an icon
858# type: what kind of application is this ? for categories: 936# type: what kind of application is this ? for categories:
859# http://standards.freedesktop.org/menu-spec/latest/apa.html 937# http://standards.freedesktop.org/menu-spec/latest/apa.html
860# path: if your app needs to startup in a specific dir 938# fields: extra fields to append to the desktop file; a printf string
861make_desktop_entry() { 939make_desktop_entry() {
862 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 940 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
863 941
864 local exec=${1} 942 local exec=${1}
865 local name=${2:-${PN}} 943 local name=${2:-${PN}}
866 local icon=${3:-${PN}} 944 local icon=${3:-${PN}}
867 local type=${4} 945 local type=${4}
868 local path=${5} 946 local fields=${5}
869 947
870 if [[ -z ${type} ]] ; then 948 if [[ -z ${type} ]] ; then
871 local catmaj=${CATEGORY%%-*} 949 local catmaj=${CATEGORY%%-*}
872 local catmin=${CATEGORY##*-} 950 local catmin=${CATEGORY##*-}
873 case ${catmaj} in 951 case ${catmaj} in
874 app) 952 app)
875 case ${catmin} in 953 case ${catmin} in
876 accessibility) type=Accessibility;; 954 accessibility) type=Accessibility;;
877 admin) type=System;; 955 admin) type=System;;
878 antivirus) type=System;; 956 antivirus) type=System;;
879 arch) type=Archiving;; 957 arch) type=Archiving;;
880 backup) type=Archiving;; 958 backup) type=Archiving;;
881 cdr) type=DiscBurning;; 959 cdr) type=DiscBurning;;
882 dicts) type=Dictionary;; 960 dicts) type=Dictionary;;
883 doc) type=Documentation;; 961 doc) type=Documentation;;
884 editors) type=TextEditor;; 962 editors) type=TextEditor;;
885 emacs) type=TextEditor;; 963 emacs) type=TextEditor;;
886 emulation) type=Emulator;; 964 emulation) type=Emulator;;
887 laptop) type=HardwareSettings;; 965 laptop) type=HardwareSettings;;
888 office) type=Office;; 966 office) type=Office;;
889 pda) type=PDA;; 967 pda) type=PDA;;
890 vim) type=TextEditor;; 968 vim) type=TextEditor;;
891 xemacs) type=TextEditor;; 969 xemacs) type=TextEditor;;
892 *) type=;;
893 esac 970 esac
894 ;; 971 ;;
895 972
896 dev) 973 dev)
897 type="Development" 974 type="Development"
898 ;; 975 ;;
899 976
900 games) 977 games)
901 case ${catmin} in 978 case ${catmin} in
902 action|fps) type=ActionGame;; 979 action|fps) type=ActionGame;;
903 arcade) type=ArcadeGame;; 980 arcade) type=ArcadeGame;;
904 board) type=BoardGame;; 981 board) type=BoardGame;;
905 emulation) type=Emulator;; 982 emulation) type=Emulator;;
906 kids) type=KidsGame;; 983 kids) type=KidsGame;;
907 puzzle) type=LogicGame;; 984 puzzle) type=LogicGame;;
908 roguelike) type=RolePlaying;; 985 roguelike) type=RolePlaying;;
909 rpg) type=RolePlaying;; 986 rpg) type=RolePlaying;;
910 simulation) type=Simulation;; 987 simulation) type=Simulation;;
911 sports) type=SportsGame;; 988 sports) type=SportsGame;;
912 strategy) type=StrategyGame;; 989 strategy) type=StrategyGame;;
913 *) type=;;
914 esac 990 esac
915 type="Game;${type}" 991 type="Game;${type}"
916 ;; 992 ;;
917 993
918 gnome) 994 gnome)
927 type="Network;Email" 1003 type="Network;Email"
928 ;; 1004 ;;
929 1005
930 media) 1006 media)
931 case ${catmin} in 1007 case ${catmin} in
1008 gfx)
932 gfx) type=Graphics;; 1009 type=Graphics
1010 ;;
1011 *)
1012 case ${catmin} in
933 radio) type=Tuner;; 1013 radio) type=Tuner;;
934 sound) type=Audio;; 1014 sound) type=Audio;;
935 tv) type=TV;; 1015 tv) type=TV;;
936 video) type=Video;; 1016 video) type=Video;;
937 *) type=;; 1017 esac
1018 type="AudioVideo;${type}"
1019 ;;
938 esac 1020 esac
939 type="AudioVideo;${type}"
940 ;; 1021 ;;
941 1022
942 net) 1023 net)
943 case ${catmin} in 1024 case ${catmin} in
944 dialup) type=Dialup;; 1025 dialup) type=Dialup;;
945 ftp) type=FileTransfer;; 1026 ftp) type=FileTransfer;;
946 im) type=InstantMessaging;; 1027 im) type=InstantMessaging;;
947 irc) type=IRCClient;; 1028 irc) type=IRCClient;;
948 mail) type=Email;; 1029 mail) type=Email;;
949 news) type=News;; 1030 news) type=News;;
950 nntp) type=News;; 1031 nntp) type=News;;
951 p2p) type=FileTransfer;; 1032 p2p) type=FileTransfer;;
952 *) type=;; 1033 voip) type=Telephony;;
953 esac 1034 esac
954 type="Network;${type}" 1035 type="Network;${type}"
955 ;; 1036 ;;
956 1037
957 sci) 1038 sci)
958 case ${catmin} in 1039 case ${catmin} in
959 astro*) type=Astronomy;; 1040 astro*) type=Astronomy;;
960 bio*) type=Biology;; 1041 bio*) type=Biology;;
961 calc*) type=Calculator;; 1042 calc*) type=Calculator;;
962 chem*) type=Chemistry;; 1043 chem*) type=Chemistry;;
963 elec*) type=Electronics;; 1044 elec*) type=Electronics;;
964 geo*) type=Geology;; 1045 geo*) type=Geology;;
965 math*) type=Math;; 1046 math*) type=Math;;
966 physics) type=Physics;; 1047 physics) type=Physics;;
967 visual*) type=DataVisualization;; 1048 visual*) type=DataVisualization;;
968 *) type=;;
969 esac 1049 esac
970 type="Science;${type}" 1050 type="Education;Science;${type}"
971 ;; 1051 ;;
972 1052
973 sys) 1053 sys)
974 type="System" 1054 type="System"
975 ;; 1055 ;;
976 1056
977 www) 1057 www)
978 case ${catmin} in 1058 case ${catmin} in
979 client) type=WebBrowser;; 1059 client) type=WebBrowser;;
980 *) type=;;
981 esac 1060 esac
982 type="Network" 1061 type="Network;${type}"
983 ;; 1062 ;;
984 1063
985 *) 1064 *)
986 type= 1065 type=
987 ;; 1066 ;;
992 else 1071 else
993 local desktop_name="${PN}-${SLOT}" 1072 local desktop_name="${PN}-${SLOT}"
994 fi 1073 fi
995 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 1074 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
996 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1075 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
1076
1077 # Don't append another ";" when a valid category value is provided.
1078 type=${type%;}${type:+;}
1079
1080 eshopts_push -s extglob
1081 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1082 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1083 ewarn "allowed in .desktop files if the value is not an absolute path."
1084 icon=${icon%.@(xpm|png|svg)}
1085 fi
1086 eshopts_pop
997 1087
998 cat <<-EOF > "${desktop}" 1088 cat <<-EOF > "${desktop}"
999 [Desktop Entry] 1089 [Desktop Entry]
1000 Name=${name} 1090 Name=${name}
1001 Type=Application 1091 Type=Application
1002 Comment=${DESCRIPTION} 1092 Comment=${DESCRIPTION}
1003 Exec=${exec} 1093 Exec=${exec}
1004 TryExec=${exec%% *} 1094 TryExec=${exec%% *}
1005 Icon=${icon} 1095 Icon=${icon}
1006 Categories=${type}; 1096 Categories=${type}
1007 EOF 1097 EOF
1008 1098
1009 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 1099 if [[ ${fields:-=} != *=* ]] ; then
1100 # 5th arg used to be value to Path=
1101 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1102 fields="Path=${fields}"
1103 fi
1104 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1010 1105
1011 ( 1106 (
1012 # wrap the env here so that the 'insinto' call 1107 # wrap the env here so that the 'insinto' call
1013 # doesn't corrupt the env of the caller 1108 # doesn't corrupt the env of the caller
1014 insinto /usr/share/applications 1109 insinto /usr/share/applications
1015 doins "${desktop}" 1110 doins "${desktop}"
1016 ) 1111 ) || die "installing desktop file failed"
1017} 1112}
1018 1113
1019# @FUNCTION: validate_desktop_entries 1114# @FUNCTION: validate_desktop_entries
1020# @USAGE: [directories] 1115# @USAGE: [directories]
1021# @MAINTAINER: 1116# @MAINTAINER:
1300 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1395 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1301 1396
1302 local shrtsrc=$(basename "${src}") 1397 local shrtsrc=$(basename "${src}")
1303 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1398 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1304 if [[ -z ${skip} ]] ; then 1399 if [[ -z ${skip} ]] ; then
1305 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1400 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1306 local skip=0 1401 local skip=0
1307 exe=tail 1402 exe=tail
1308 case ${ver} in 1403 case ${ver} in
1309 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1404 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1310 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1405 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1312 2.0|2.0.1) 1407 2.0|2.0.1)
1313 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1408 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1314 ;; 1409 ;;
1315 2.1.1) 1410 2.1.1)
1316 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1411 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1317 let skip="skip + 1" 1412 (( skip++ ))
1318 ;; 1413 ;;
1319 2.1.2) 1414 2.1.2)
1320 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1415 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1321 let skip="skip + 1" 1416 (( skip++ ))
1322 ;; 1417 ;;
1323 2.1.3) 1418 2.1.3)
1324 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1419 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1325 let skip="skip + 1" 1420 (( skip++ ))
1326 ;; 1421 ;;
1327 2.1.4|2.1.5) 1422 2.1.4|2.1.5)
1328 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1423 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1329 skip=$(head -n ${skip} "${src}" | wc -c) 1424 skip=$(head -n ${skip} "${src}" | wc -c)
1330 exe="dd" 1425 exe="dd"
1339 esac 1434 esac
1340 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1435 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1341 fi 1436 fi
1342 case ${exe} in 1437 case ${exe} in
1343 tail) exe="tail -n +${skip} '${src}'";; 1438 tail) exe="tail -n +${skip} '${src}'";;
1344 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1439 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1345 *) die "makeself cant handle exe '${exe}'" 1440 *) die "makeself cant handle exe '${exe}'"
1346 esac 1441 esac
1347 1442
1348 # lets grab the first few bytes of the file to figure out what kind of archive it is 1443 # lets grab the first few bytes of the file to figure out what kind of archive it is
1349 local tmpfile=$(emktemp) 1444 local filetype tmpfile=$(emktemp)
1350 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1445 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1351 local filetype=$(file -b "${tmpfile}") 1446 filetype=$(file -b "${tmpfile}") || die
1352 case ${filetype} in 1447 case ${filetype} in
1353 *tar\ archive*) 1448 *tar\ archive*)
1354 eval ${exe} | tar --no-same-owner -xf - 1449 eval ${exe} | tar --no-same-owner -xf -
1355 ;; 1450 ;;
1356 bzip2*) 1451 bzip2*)
1482 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1577 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1483 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1578 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1484 export CDROM_SET=-1 1579 export CDROM_SET=-1
1485 for f in ${CDROM_CHECK_1//:/ } ; do 1580 for f in ${CDROM_CHECK_1//:/ } ; do
1486 ((++CDROM_SET)) 1581 ((++CDROM_SET))
1487 [[ -e ${CD_ROOT}/${f} ]] && break 1582 [[ -e ${CDROM_ROOT}/${f} ]] && break
1488 done 1583 done
1489 export CDROM_MATCH=${f} 1584 export CDROM_MATCH=${f}
1490 return 1585 return
1491 fi 1586 fi
1492 1587
1666 else 1761 else
1667 newls="" 1762 newls=""
1668 fi 1763 fi
1669 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do 1764 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1670 if [[ ${op} == "-i" ]] ; then 1765 if [[ ${op} == "-i" ]] ; then
1671 hasq ${f} ${ls} && newls="${newls} ${f}" 1766 has ${f} ${ls} && newls="${newls} ${f}"
1672 else 1767 else
1673 hasq ${f} ${ls} || newls="${newls} ${f}" 1768 has ${f} ${ls} || newls="${newls} ${f}"
1674 fi 1769 fi
1675 done 1770 done
1676 ls=${newls} 1771 ls=${newls}
1677 done 1772 done
1678 else 1773 else
1680 fi 1775 fi
1681 1776
1682 nols="" 1777 nols=""
1683 newls="" 1778 newls=""
1684 for f in ${LINGUAS} ; do 1779 for f in ${LINGUAS} ; do
1685 if hasq ${f} ${ls} ; then 1780 if has ${f} ${ls} ; then
1686 newls="${newls} ${f}" 1781 newls="${newls} ${f}"
1687 else 1782 else
1688 nols="${nols} ${f}" 1783 nols="${nols} ${f}"
1689 fi 1784 fi
1690 done 1785 done
1745 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1840 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1746 ewarn "in order to remove these old dependencies. If you do not have this" 1841 ewarn "in order to remove these old dependencies. If you do not have this"
1747 ewarn "helper program, simply emerge the 'gentoolkit' package." 1842 ewarn "helper program, simply emerge the 'gentoolkit' package."
1748 ewarn 1843 ewarn
1749 fi 1844 fi
1845 # temp hack for #348634 #357225
1846 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1750 ewarn " # revdep-rebuild --library ${lib##*/}" 1847 ewarn " # revdep-rebuild --library '${lib}'"
1751 done 1848 done
1752 if [[ ${notice} -eq 1 ]] ; then 1849 if [[ ${notice} -eq 1 ]] ; then
1753 ewarn 1850 ewarn
1754 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1851 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1755 ewarn "delete the old libraries. Here is a copy & paste for the lazy:" 1852 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1901 else 1998 else
1902 newbin "${tmpwrapper}" "${wrapper}" || die 1999 newbin "${tmpwrapper}" "${wrapper}" || die
1903 fi 2000 fi
1904} 2001}
1905 2002
1906# @FUNCTION: prepalldocs 2003# @FUNCTION: path_exists
1907# @USAGE: 2004# @USAGE: [-a|-o] <paths>
1908# @DESCRIPTION: 2005# @DESCRIPTION:
1909# Compress files in /usr/share/doc which are not already 2006# Check if the specified paths exist. Works for all types of paths
1910# compressed, excluding /usr/share/doc/${PF}/html. 2007# (files/dirs/etc...). The -a and -o flags control the requirements
1911# Uses the ecompressdir to do the compression. 2008# of the paths. They correspond to "and" and "or" logic. So the -a
1912# 2009-02-18 by betelgeuse: 2009# flag means all the paths must exist while the -o flag means at least
1913# Commented because ecompressdir is even more internal to 2010# one of the paths must exist. The default behavior is "and". If no
1914# Portage than prepalldocs (it's not even mentioned in man 5 2011# paths are specified, then the return value is "false".
1915# ebuild). Please submit a better version for review to gentoo-dev 2012path_exists() {
1916# if you want prepalldocs here. 2013 local opt=$1
1917#prepalldocs() { 2014 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1918# if [[ -n $1 ]] ; then
1919# ewarn "prepalldocs: invalid usage; takes no arguments"
1920# fi
1921 2015
1922# cd "${D}" 2016 # no paths -> return false
1923# [[ -d usr/share/doc ]] || return 0 2017 # same behavior as: [[ -e "" ]]
2018 [[ $# -eq 0 ]] && return 1
1924 2019
1925# find usr/share/doc -exec gzip {} + 2020 local p r=0
1926# ecompressdir --ignore /usr/share/doc/${PF}/html 2021 for p in "$@" ; do
1927# ecompressdir --queue /usr/share/doc 2022 [[ -e ${p} ]]
1928#} 2023 : $(( r += $? ))
2024 done
2025
2026 case ${opt} in
2027 -a) return $(( r != 0 )) ;;
2028 -o) return $(( r == $# )) ;;
2029 esac
2030}

Legend:
Removed from v.1.330  
changed lines
  Added in v.1.363

  ViewVC Help
Powered by ViewVC 1.1.20